<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "cpn_software_version_log".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "CpnSoftwareVersionLog".
 *
 * Columns in table "cpn_software_version_log" available as properties of the model,
 * followed by relations of table "cpn_software_version_log" available as properties of the model.
 *
 * @property integer $id
 * @property string $guid
 * @property integer $cpn_installation_id
 * @property integer $cpn_software_version_id
 * @property integer $success_flag
 * @property integer $del_flag
 * @property string $ip_address
 * @property string $date_added
 * @property integer $added_by_account_id
 * @property string $date_updated
 * @property integer $updated_by_account_id
 *
 * @property Account $addedByAccount
 * @property CpnInstallation $cpnInstallation
 * @property CpnSoftwareVersion $cpnSoftwareVersion
 * @property Account $updatedByAccount
 */
abstract class BaseCpnSoftwareVersionLog extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'cpn_software_version_log';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'CpnSoftwareVersionLog|CpnSoftwareVersionLogs', $n);
    }

    public static function representingColumn()
    {
        return 'date_added';
    }

    public function rules()
    {
        return array(
            array('cpn_installation_id, cpn_software_version_id, success_flag, added_by_account_id', 'required'),
            array('cpn_installation_id, cpn_software_version_id, success_flag, del_flag, added_by_account_id, '
                . 'updated_by_account_id', 'numerical', 'integerOnly' => true),
            array('guid', 'length', 'max' => 255),
            array('ip_address', 'length', 'max' => 15),
            array('date_added, date_updated', 'safe'),
            array('guid, del_flag, ip_address, date_added, date_updated, updated_by_account_id', 'default',
                'setOnEmpty' => true, 'value' => null),
            array('id, guid, cpn_installation_id, cpn_software_version_id, success_flag, del_flag, ip_address, '
                . 'date_added, added_by_account_id, date_updated, updated_by_account_id', 'safe', 'on' => 'search'),
        );
    }

    public function relations()
    {
        return array(
            'addedByAccount' => array(self::BELONGS_TO, 'Account', 'added_by_account_id'),
            'cpnInstallation' => array(self::BELONGS_TO, 'CpnInstallation', 'cpn_installation_id'),
            'cpnSoftwareVersion' => array(self::BELONGS_TO, 'CpnSoftwareVersion', 'cpn_software_version_id'),
            'updatedByAccount' => array(self::BELONGS_TO, 'Account', 'updated_by_account_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'guid' => Yii::t('app', 'Guid'),
            'cpn_installation_id' => null,
            'cpn_software_version_id' => null,
            'success_flag' => Yii::t('app', 'Success Flag'),
            'del_flag' => Yii::t('app', 'Del Flag'),
            'ip_address' => Yii::t('app', 'Ip Address'),
            'date_added' => Yii::t('app', 'Date Added'),
            'added_by_account_id' => null,
            'date_updated' => Yii::t('app', 'Date Updated'),
            'updated_by_account_id' => null,
            'addedByAccount' => null,
            'cpnInstallation' => null,
            'cpnSoftwareVersion' => null,
            'updatedByAccount' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('guid', $this->guid, true);
        $criteria->compare('cpn_installation_id', $this->cpn_installation_id);
        $criteria->compare('cpn_software_version_id', $this->cpn_software_version_id);
        $criteria->compare('success_flag', $this->success_flag);
        $criteria->compare('del_flag', $this->del_flag);
        $criteria->compare('ip_address', $this->ip_address, true);
        $criteria->compare('date_added', $this->date_added, true);
        $criteria->compare('added_by_account_id', $this->added_by_account_id);
        $criteria->compare('date_updated', $this->date_updated, true);
        $criteria->compare('updated_by_account_id', $this->updated_by_account_id);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria,
        ));
    }

}
